

var aDefaults 	= new Array();
	aDefaults[0]	= "http://mozmonkey.com/bandwidthtest/test/loadBalance.php?l=1";
	aDefaults[1]	= "http://mozmonkey.com/bandwidthtest/test/loadBalance.php?l=2";
	aDefaults[2]	= "http://mozmonkey.com/bandwidthtest/test/loadBalance.php?l=3";
	aDefaults[3]	= "http://mozmonkey.com/bandwidthtest/test/loadBalance.php?l=4";
	aDefaults[4]	= "http://mozmonkey.com/bandwidthtest/test/loadBalance.php?l=5";

var aLevels = aDefaults;
	
var iSumBits		= 0;
var iSumBytes		= 0;
var iCount			= 0;
var iLevelCount		= 0;
var iLevel			= 0;
var iAll			= 0;
var iStop			= 5;

var oLogs			= null;
var oLogItems		= null;
var oLogRow			= null;
var oTotal			= null;
var oButton			= null;
var oProgress		= null;
var oConnection		= null;
var oRequest		= null;
var sContent		= "";

var iTimeStart		= 0;


function bandwidthtest_init(){
	oLogs 		= document.getElementById("log-tree");
	oLogItems	= document.getElementById("log-items");
	oTotal 		= document.getElementById("results-field");
	oButton		= document.getElementById("test-button");
	oProgress 	= document.getElementById("test-progress");
	oConnection	= document.getElementById("connection-list");
	
	setTimeout("bandwidthtest_autoUpdate()", 500);
}

function bandwidthtest_reset(){
	iSumBits			= 0;
	iSumBytes			= 0;
	iCount				= 0;
	iLevelCount			= 0;
	iAll				= 0;
	oTotal.value 		= "";
	oProgress.value	= 0;
	
	// Remove tree items
	var aRows = oLogItems.childNodes;
	for(var i = (aRows.length - 1); i >= 0 ; i--){
		oLogItems.removeChild(aRows[i]);
	}
}

function bandwidthtest_runTest(){
	bandwidthtest_reset();
	
	oButton.disabled = true;
	oProgress.style.display = "block";
	
	// Get Test Files
	var aTmpLevels = new Array();
	var oPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
	if(oPrefs.prefHasUserValue("bandwidthtest.files.1") && oPrefs.getCharPref("bandwidthtest.files.1").search(/[a-z0-9]/i) > -1 && oPrefs.getCharPref("bandwidthtest.files.1").indexOf("mozmonkey.com") < 0 && oPrefs.getCharPref("bandwidthtest.files.1").indexOf("nettripper.com") < 0)
			aTmpLevels[aTmpLevels.length] = oPrefs.getCharPref("bandwidthtest.files.1");
	if(oPrefs.prefHasUserValue("bandwidthtest.files.2") && oPrefs.getCharPref("bandwidthtest.files.2").search(/[a-z0-9]/i) > -1 && oPrefs.getCharPref("bandwidthtest.files.2").indexOf("mozmonkey.com") < 0 && oPrefs.getCharPref("bandwidthtest.files.1").indexOf("nettripper.com") < 0)
			aTmpLevels[aTmpLevels.length] = oPrefs.getCharPref("bandwidthtest.files.2")
	if(oPrefs.prefHasUserValue("bandwidthtest.files.3") && oPrefs.getCharPref("bandwidthtest.files.3").search(/[a-z0-9]/i) > -1 && oPrefs.getCharPref("bandwidthtest.files.3").indexOf("mozmonkey.com") < 0 && oPrefs.getCharPref("bandwidthtest.files.1").indexOf("nettripper.com") < 0)
			aTmpLevels[aTmpLevels.length] = oPrefs.getCharPref("bandwidthtest.files.3");
	if(oPrefs.prefHasUserValue("bandwidthtest.files.4") && oPrefs.getCharPref("bandwidthtest.files.4").search(/[a-z0-9]/i) > -1 && oPrefs.getCharPref("bandwidthtest.files.4").indexOf("mozmonkey.com") < 0 && oPrefs.getCharPref("bandwidthtest.files.1").indexOf("nettripper.com") < 0)
			aTmpLevels[aTmpLevels.length] = oPrefs.getCharPref("bandwidthtest.files.4");
	if(oPrefs.prefHasUserValue("bandwidthtest.files.5") && oPrefs.getCharPref("bandwidthtest.files.5").search(/[a-z0-9]/i) > -1 && oPrefs.getCharPref("bandwidthtest.files.5").indexOf("mozmonkey.com") < 0 && oPrefs.getCharPref("bandwidthtest.files.1").indexOf("nettripper.com") < 0)
			aTmpLevels[aTmpLevels.length] = oPrefs.getCharPref("bandwidthtest.files.5");
	
	if(aTmpLevels.length > 0)
		aLevels = aTmpLevels; 
	
	// Get Connection
	if(oConnection.selectedItem.value != "-1"){	
		iStop 	= 3;
		iLevel	= parseInt(oConnection.selectedItem.value);
		
		if(isNaN(iLevel) || typeof(aLevels[iLevel]) == 'undefined'){
			iLevel	= 0;
			iStop	= 5;
		}
	}
	
	setTimeout("bandwidthtest_fetchUrl()", 500);
}

function bandwidthtest_endTest(){
	
	iServerTime				= 0;
	trackServerTime			= false;
	oButton.disabled 		= false;
	oProgress.style.display = "none";
	
	if(iSumBits == 0 || iSumBytes == 0){
		oTotal.value = "An error occurred";
	}
	else{
		oTotal.value = "~ "+ bandwidthtest_getBandwidthString(iSumBits / iCount, true);
		oTotal.value += "    --    "+ bandwidthtest_getBandwidthString(iSumBytes / iCount, false);
	}
		
}

function bandwidthtest_fetchUrl(){
	try{
		iAll++;
		iLevelCount++;
			
		// Random Number)
		var sUrl = aLevels[iLevel];
		if(sUrl.indexOf("?") == -1){
			sUrl += "?";
		}
		sUrl += "&rand="+ Math.round(Math.random() * 200);
	
		oLogRow = bandwidthtest_msgLoggRow(sUrl, 0);
		
		/* oRequest	= new XMLHttpRequest();
		iTimeStart	= (new Date()).getTime(); */
		
		// Send Request
		/*oRequest.open("GET", sUrl, true);
		oRequest.onload = bandwidthtest_loader;
		oRequest.send("");*/
		
		if(oRequest != null){
			oRequest.cancel(null);
		}
		
		var io			= Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var uri			= Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
			uri.spec	= sUrl;
		oRequest		= io.newChannelFromURI(uri).QueryInterface(Components.interfaces.nsIHttpChannel);
		oRequest.asyncOpen(bandwidthtest_loader, null);
	
	}catch(e){ debug("Load Error ("+ iLevel +") "+ e); }
}

// Finish Request and start the next one
const bandwidthtest_loader = {
	
	input : null,
	start : 0,
	content : "",
	all : "",
	earlyStart : 0,
	
	onStartRequest : function(request, ctxt) { 
		this.input = null;
		this.start = 0;
		this.content = "";
		this.all = "";
		this.earlyStart = (new Date()).getTime();
	},
	onDataAvailable : function(request, ctxt, input, offset, count) {		
		try{
			if(this.start == 0){
				bandwidthtest_msgLoggRow(oRequest.URI.spec, 1, oLogRow);
				
				this.input = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
				this.input.init(input);
				this.start = (new Date()).getTime();
				this.input.read(count);
				this.all += this.input.read(count);
			}
			else{
				var load = this.input.read(count);
				this.content += load;
				this.all += load;
			}
			
		}catch(e){
			debug("ERROR "+ e);  
		}
	},
	onStopRequest : function(request, ctxt, status) {
		
		if(this.content.length == 0 && this.all > 0){
			this.content = this.all;
			this.start = this.earlyStart
		}
	
		debug("DONE ("+ (this.content.length / 1024).toFixed(7) +")");
		
		try{
			bandwidthtest_msgLoggRow(oRequest.URI.spec, 2, oLogRow);
		
			var iTime		= 0
			var iSize		= 0;
			var sResponse	= "";
			
			// Get Response
			var iStopTime 	= (new Date()).getTime();
			
			// Get Average
			if(this.content.length == 0 && this.all.length == 0){ // no divide by zero
				bandwidthtest_logError(oLogRow, "No data");
			}
			else{
				iCount++;
				
				iTime = ((iStopTime - this.start) / 1000).toFixed(3); //seconds
				
				// prevent divide by zero error
				if(iTime == 0)
					iTime = 0.1;
				
				iSize 		= (this.content.length / 1024).toFixed(7);
				iSumBytes	+= parseInt((iSize / iTime).toPrecision(15));
				bandwidthtest_logTime(oLogRow, iTime, iSize);
				
				iSize 		= (iSize * 8); //kilobits
				iSumBits	+= parseInt((iSize / iTime).toPrecision(15));
			}
			
			// Level Increment or End
			if(iAll > iStop){ // End
				bandwidthtest_endTest();
				return;
			}
			else if(iTime > 2 && iLevel > 0){ // Down a level
				iLevelCount = 0;
				iLevel--;
			}
			else if(iTime < 0.3 && iLevel < 3){ // Go up one level
				iLevelCount = 0;
				iLevel += 2;
			}
			else if(iTime < 0.6 && iLevel < 4){ // Go up one level
				iLevelCount = 0;
				iLevel++;
			}
			
		}catch(err){ 
			debug("Error "+ err);
			bandwidthtest_logError(oLogRow, err); 
		}
		
		
		// Set Progress
		try{
			oProgress.value = (100 / iStop) * iAll;
		}catch(e){}
		
		// Loop
		setTimeout("bandwidthtest_fetchUrl()", 500);
	}
}

// Add loadding... log
function bandwidthtest_msgLoggRow(url, phase, row){
	try{
		var msg = "";
		if(url.indexOf(aDefaults[iLevel]) == 0){
			switch(phase){
				case 1:
					msg = "Downloading...";
					break;
				case 2:
					msg = "Calculating...";
					break;
				default:
					msg = "Connecting...";
			}
		}
		else{
			msg = url;
		}
	
		if(typeof(row) == 'undefined'){
			var oLogItem 	= document.createElement("treeitem");
			var oLogRow		= oLogItem.appendChild(document.createElement("treerow"));
			var oLogDesc	= oLogRow.appendChild(document.createElement("treecell"));
			var oLogSize	= oLogRow.appendChild(document.createElement("treecell"));
			var oLogTime	= oLogRow.appendChild(document.createElement("treecell"));
			
			oLogDesc.setAttribute("label", msg);
			oLogSize.setAttribute("label", " -- ");
			oLogTime.setAttribute("label", " -- ");
			
			// Append
			oLogItems.appendChild(oLogItem);
			
			// Make visible
			oLogs.treeBoxObject.ensureRowIsVisible(oLogItems.childNodes.length);
			
			return oLogRow;
		}
		else{
			row.childNodes[0].setAttribute("label", msg);
		}
		
	}catch(e){ debug("Log Error "+ e); }
	
	return null;
}

// Log Time in results tree
function bandwidthtest_logTime(oLogRow, seconds, size){
		
	var port = (oRequest.URI.port > 0) ? ":" + oRequest.URI.port : "";
	var url	= "http://"+ oRequest.URI.host + ".com" + port + oRequest.URI.path;
	
	if(oLogRow != null){
		oLogRow.childNodes[0].setAttribute("label", url);
		oLogRow.childNodes[1].setAttribute("label", (size / 8).toFixed(2) +" KB");
		oLogRow.childNodes[2].setAttribute("label", seconds);
	}
}

// Log an error
function bandwidthtest_logError(logRow, error){
	if(logRow != null){
		logRow.childNodes[0].setAttribute("label", error);
		logRow.childNodes[1].setAttribute("label", "--");
		logRow.childNodes[2].setAttribute("label", "--");
	}
}

// Translate Bandwith
function bandwidthtest_getBandwidthString(iTimePer, inBits){
	var sUnit 		= "kilo" + ((inBits) ? "bits" : "bytes");
	
	if(iTimePer > 1000){
		iTimePer 	= iTimePer / 1024;
		sUnit		= "mega" + ((inBits) ? "bits" : "bytes");
	}
	else if(sTimePer < 0.0){
		iTimePer 	= iTimePer * 1024;
		sUnit		= (inBits) ? "bits" : "bytes";
	}
	
	// Trim
	var iDec 		= -1;
	var sTimePer	= iTimePer + "";
	if((iDec = sTimePer.indexOf(".")) > -1 && (sTimePer.length - iDec) > 2){
		sTimePer = sTimePer.substring(0, (iDec + 3));
	}
	
	return sTimePer +" "+ sUnit +"/sec";
}

// Open Options
function options(){
	window.openDialog("chrome://bandwidthtest/content/options.xul", "bandwithTestOptions", "centerscreen, chrome, modal")	
}

// Add debug statments
function debug(msg, level){
	return;

	var lev = 3;
	if(typeof(level) != 'undefined'){
		lev = level;
	}
	
	if(typeof(Components.classes["@mozmonkey.com/debuglogger/manager;1"]) != 'undefined'){
		var logMngr = Components.classes["@mozmonkey.com/debuglogger/manager;1"].getService(Components.interfaces.nsIDebugLoggerManager);
		var logger = logMngr.getLogger("bandwidthtest");
		if(logger == null){
			logger = logMngr.registerLogger("bandwidthtest");
		}
		logger.log(lev, msg);
	}
}